SystemOrganization addCategory: #ConfigurationOfPatrik!

Object subclass: #ConfigurationOfPatrik
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPatrik'!

!ConfigurationOfPatrik class methodsFor: 'development support' stamp: 'PatrikSundberg 7/24/2012 16:35'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfPatrik class methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 16:37'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPatrik class methodsFor: 'building' stamp: 'PatrikSundberg 7/24/2012 16:43'!
buildCommanderImage
	CommanderImageBuilder new buildImage.! !

!ConfigurationOfPatrik class methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 16:36'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPatrik class methodsFor: 'private' stamp: 'PatrikSundberg 7/25/2012 12:06'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPatrik class methodsFor: 'metacello tool support' stamp: 'PatrikSundberg 7/24/2012 16:36'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPatrik class methodsFor: 'metacello tool support' stamp: 'PatrikSundberg 7/25/2012 12:07'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPatrik class methodsFor: 'metacello tool support' stamp: 'PatrikSundberg 7/25/2012 12:07'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPatrik class methodsFor: 'loading' stamp: 'PatrikSundberg 7/24/2012 16:42'!
loadCommander
	CommanderImageBuilder new loadPackages: 'Commander'! !

!ConfigurationOfPatrik class methodsFor: 'metacello tool support' stamp: 'PatrikSundberg 7/25/2012 12:07'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPatrik class methodsFor: 'accessing' stamp: 'PatrikSundberg 7/24/2012 16:34'!
project

	^self new project! !

!ConfigurationOfPatrik class methodsFor: 'development support' stamp: 'PatrikSundberg 7/25/2012 12:08'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPatrik methodsFor: 'baselines' stamp: 'PatrikSundberg 7/30/2012 11:39'!
baseline10: spec
	<version: '1.0-baseline'>
       
	spec for: #pharo  do: [
		spec blessing: #baseline.
 			" spec 
				project: 'Commander'
				with:
					[ spec
						className: 'ConfigurationOfCommander';
						loads: #('DevelopmentGroup' );
						file: 'ConfigurationOfCommander';
						versionString: #bleedingEdge;
						repository: 'http://ss3.gemstone.com/ss/Commander' ].
			"
		
		spec
			project: 'TilingWindowManager' 
			with: [
				spec
					className: 'ConfigurationOfTilingWindowManager';
					loads: #('default');
					file: 'ConfigurationOfTilingWindowManager';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/TilingWindowManager' ].
		
"		spec
			project: 'GlamourCore'
			with: [
				spec
					className: 'ConfigurationOfGlamour';
					loads: #('Core' 'Morphic' );
					file: 'ConfigurationOfGlamour';
					versionString: #bleedingEdge;
					repository: 'http://www.squeaksource.com/Glamour' ].
"	
		spec 
			project: 'Keymapping' 
			with: [
				spec
					className: 'ConfigurationOfKeymapping';
					loads: #('forDeveloper' );
					file: 'ConfigurationOfKeymapping';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/ShortWays' ].
				
		spec 
			project: 'Spotlight'
			with: [
				spec
					className: 'ConfigurationOfSpotlight';
					file: 'ConfigurationOfSpotlight';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/Spotlight' ].

"
		spec 
			package: 'GT-Inspector' 
			with: [
				spec
					repository: 'http://www.squeaksource.com/glamoroust';
					requires: #('GlamourCore') ].
"			
		spec
			group: 'CommanderImage' 
			with: #( 'BaseImage'). " 'Commander'). add this in later.."
				
		spec
			group: 'BaseImage' 
			with: #('TilingWindowManager' 'Keymapping' 'Spotlight' ).
	 ].
"
	spec for: #'pharo1.4.x' do: [
		spec 
			project: 'NautilusWithRBAndOCompletion' 
			with:  [
				spec
					className: 'ConfigurationOfNautilus';
					file: 'ConfigurationOfNautilus';
					versionString: #stable;
					loads: 'release';
					repository: 'http://ss3.gemstone.com/ss/Nautilus' ].
			
		spec 
			group: 'BaseImage' 
			with: #( 'NautilusWithRBAndOCompletion Unmatched string quote -> Unmatched string quote ->'  ). 
	].
"! !

!ConfigurationOfPatrik methodsFor: 'accessing' stamp: 'PatrikSundberg 7/25/2012 12:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]
! !

Object subclass: #PSGeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: 'BuildOffline'
	poolDictionaries: ''
	category: 'ConfigurationOfPatrik'!

PSGeneralImageBuilder subclass: #CommanderImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfPatrik'!

!CommanderImageBuilder methodsFor: 'saving' stamp: 'PatrikSundberg 7/24/2012 17:31'!
baseImageName
	^ 'Commander'! !

!CommanderImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/24/2012 17:32'!
customPreferences
	Debugger logFileName: 'CommanderDebug.log'.! !

!CommanderImageBuilder methodsFor: 'saving' stamp: 'PatrikSundberg 7/24/2012 17:32'!
imageDirectory
	^ '/home/pts/pharo/cdr/images/'! !

!CommanderImageBuilder methodsFor: 'loading' stamp: 'PatrikSundberg 7/24/2012 17:33'!
imageGroupNameToLoad
	^ 'CommanderImage'.	
! !

!CommanderImageBuilder methodsFor: 'accessing' stamp: 'PatrikSundberg 7/24/2012 17:33'!
repositoryName 
	^ 'http://ss3.gemstone.com/ss/Commander'
! !

!PSGeneralImageBuilder class methodsFor: 'accessing' stamp: 'PatrikSundberg 7/24/2012 16:45'!
buildOffline
	BuildOffline ifNil: [ BuildOffline := false ].
	^ BuildOffline! !

!PSGeneralImageBuilder class methodsFor: 'accessing' stamp: 'PatrikSundberg 7/24/2012 16:45'!
buildOffline: aBoolean
	BuildOffline := aBoolean! !

!PSGeneralImageBuilder methodsFor: 'building' stamp: 'PatrikSundberg 7/24/2012 16:47'!
buildImage
	self loadImagePackages.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self lastActions.
	self saveImage.! !

!PSGeneralImageBuilder methodsFor: 'cleaning' stamp: 'PatrikSundberg 7/30/2012 11:43'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].
	" TOD: add this back in: Spotlight reset. "

	"Clear Monticello Caches"
	MCFileBasedRepository flushAllCaches.
	MCMethodDefinition shutDown.
	MCDefinition clearInstances.

	"Cleanup Smalltalk"
	Smalltalk flushClassNameCache.
	Smalltalk organization removeEmptyCategories.
	Smalltalk allClassesAndTraitsDo: [ :each |
		each organization removeEmptyCategories; sortCategories.
		each class organization removeEmptyCategories; sortCategories ].
	
	"Cleanup System Memory"
	Smalltalk garbageCollect.
	Symbol compactSymbolTable.
	
	ScriptLoader new cleanUpForRelease.	

	"put back the author"
	Author fullName: 'PatrikSundberg'.
	! !

!PSGeneralImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/24/2012 16:56'!
customPreferences
	" can be overriden by child classes to specify any project specific preferences "! !

!PSGeneralImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/30/2012 11:41'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.
	Parser warningAllowed: false. 
	TasklistMorph keepOpen: true.
	"(Smalltalk at: #TWMBar) showTWMBar: true."
	"Smalltalk tools register: (Smalltalk at: #GTInspector)  as: #objectExplorer."
	" GTPlayground is not yet working correctly, so I disable it for the moment"
	"Smalltalk tools register: (Smalltalk at: #GTPlayground)  as: #workspace."
	"Nautilus showHierarchy: true. 
	Nautilus switchClassesAndPackages: false.
	(Smalltalk globals includesKey: #AnnotationPanePlugin)
		ifTrue: [Nautilus pluginClasses add: { AnnotationPanePlugin. #middle }.].
	Nautilus pluginClasses add: { NautilusBreadcrumbsPlugin. #top }.
	"! !

!PSGeneralImageBuilder methodsFor: 'loading' stamp: 'PatrikSundberg 7/25/2012 12:21'!
generalPreLoad
	"MCCacheRepository default directory: self sharedPackageCacheDirectory.
	MCDirectoryRepository defaultDirectoryName: self sharedPackageCacheName.
	"
	Author fullName: 'PatrikSundberg'.! !

!PSGeneralImageBuilder methodsFor: 'loading' stamp: 'PatrikSundberg 7/24/2012 16:53'!
imageGroupNameToLoad
	^ self subclassResponsibility ! !

!PSGeneralImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/24/2012 16:57'!
isPharo14 
	^ SystemVersion current minor = 4
! !

!PSGeneralImageBuilder methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 17:09'!
isSS3: aRepo

	^ aRepo locationWithTrailingSlash includesSubString: 'http://ss3.gemstone.com/ss/'
		! !

!PSGeneralImageBuilder methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 17:09'!
isSS: aRepo

	^ aRepo locationWithTrailingSlash includesSubString: 'www.squeaksource.com'		! !

!PSGeneralImageBuilder methodsFor: 'building' stamp: 'PatrikSundberg 7/24/2012 17:16'!
lastActions
	self putMyRepositoriesAtTheEnd.
	self setUsernameAndPasswordForRepos.! !

!PSGeneralImageBuilder methodsFor: 'loading' stamp: 'PatrikSundberg 7/24/2012 16:53'!
loadImagePackages
	self loadPackages: self imageGroupNameToLoad.! !

!PSGeneralImageBuilder methodsFor: 'loading' stamp: 'PatrikSundberg 7/30/2012 11:34'!
loadPackages: packagesOrGroups
	| version repo |
	self generalPreLoad.
	version := (ConfigurationOfPatrik project version: #bleedingEdge).
	self class buildOffline 
		ifTrue: [ 
			repo := MCDirectoryRepository new.
  			repo directory: self sharedPackageCacheDirectory.
 	 		version repositoryOverrides: (OrderedCollection with: repo). ].
	
	version load: packagesOrGroups.! !

!PSGeneralImageBuilder methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 16:59'!
putMyRepositoriesAtTheEnd
	| myRepo |
	myRepo :=  MCRepositoryGroup default repositories 
		detect: [:each | each description = self repositoryName]
		ifNone: [ "this means it was loaded offline used the shared package cache, so I do nothing" ^ self ].
	MCRepositoryGroup default  removeRepository: myRepo.
	MCRepositoryGroup default  addRepository: myRepo.
! !

!PSGeneralImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/30/2012 12:06'!
repositoriesPassword
	| passwordFile |
	passwordFile := FileDirectory default oldFileNamed: '/home/pts/pharo/repositories_password.txt'.
	^passwordFile contents trimRight: [ :each | each = Character cr ].
		! !

!PSGeneralImageBuilder methodsFor: 'accessing' stamp: 'PatrikSundberg 7/24/2012 16:46'!
repositoryName
	^ self subclassResponsibility ! !

!PSGeneralImageBuilder methodsFor: 'saving' stamp: 'PatrikSundberg 7/24/2012 17:29'!
saveImage

	self 
		saveImageAs: self baseImageName 
		inDirectoryNamed: self imageDirectory! !

!PSGeneralImageBuilder methodsFor: 'saving' stamp: 'PatrikSundberg 7/30/2012 12:11'!
saveImageAs: imageName inDirectoryNamed: aDirectoryString

	| newName index |

	" TODO: StartupLoader default removeAllScriptsAndCleanSavedActions. "
	
	(FileDirectory default fileExists: (aDirectoryString , imageName, '.' , FileDirectory changeSuffix))
		ifTrue:
			[ newName := (FileDirectory on: aDirectoryString ) nextNameFor: imageName extension: FileDirectory imageSuffix.
			index := newName findLast: [:c | c = $.].
			newName := newName copyFrom: 1 to: (index - 1).	]
		ifFalse: [ newName := imageName ].
		
	newName isEmptyOrNil
		ifTrue: [ ^ self ].
		
	(SourceFiles at: 2) ifNotNil:
		[Smalltalk closeSourceFiles; "so copying the changes file will always work"
			 saveChangesInFileNamed: (aDirectoryString , newName, '.' , FileDirectory changeSuffix)].
	^Smalltalk saveImageInFileNamed: (aDirectoryString , newName, '.', FileDirectory imageSuffix)! !

!PSGeneralImageBuilder methodsFor: 'preferences' stamp: 'PatrikSundberg 7/24/2012 16:58'!
setLogoFromFileNamed: aFilename
	self isPharo14 ifTrue: [PolymorphSystemSettings showDesktopLogo: false].
	" seems LogoImageMorth is not in my image.. "
	" LogoImageMorph default: (ImageMorph withForm: (ImageReadWriter formFromFileNamed: aFilename)). "
	! !

!PSGeneralImageBuilder methodsFor: 'startUp' stamp: 'PatrikSundberg 7/30/2012 11:36'!
setPersonalStartUpPrefernces
	"self setPersonalStartUpPrefernces"
	| items |
	items := OrderedCollection new.

	items add: (StartupAction name: 'General Preferences for all Pharo versions' code: [
		FileStream stdout lf; nextPutAll: 'Setting general preferences for all Pharo versions'; lf.
		Author fullName: 'PatrikSundberg'.
		FileStream stdout lf; nextPutAll: 'Finished'; lf.
		]).
	StartupLoader default addAtStartupInGeneralPreferenceFolder: items named: 'generalSettings.st'.

	items removeAll.
	items add: (StartupAction name: 'Settings' code: [
		FileStream stdout lf; nextPutAll: 'Setting general preferences'; lf.
		UITheme currentSettings fastDragging: true.
		CodeHolder showAnnotationPane: true.
		MCCodeTool showAnnotationPane: true.
		Deprecation raiseWarning: true.
		Debugger alwaysOpenFullDebugger: true.
		Parser warningAllowed: false.
		FileStream stdout lf; nextPutAll: 'Finished'; lf.
	]).
	StartupLoader default addAtStartupInPreferenceVersionFolder: items named: 'settings.st'.

	items removeAll.
	"items add: (StartupAction name: 'Nautilus' code: [
		FileStream stdout lf; nextPutAll: 'Executing Nautilus related stuff'; lf.
		Nautilus pluginClasses add: { NautilusBreadcrumbsPlugin. #top }.
		Nautilus pluginClasses add: { AnnotationPanePlugin. #middle }.
		FileStream stdout lf; nextPutAll: 'Finished'; lf.
	] runOnce: true).
	StartupLoader default addAtStartupInPreferenceVersionFolder: items named: 'nautilus.st'.
"

	items removeAll.
	items add: (StartupAction name: 'Monticello related stuff' code: [
		| sharedPackageCacheDirectory |
		FileStream stdout lf; nextPutAll: 'Executing Monticello related stuff'; lf.
		sharedPackageCacheDirectory := (FileDirectory on: '/home/pts/pharo/local-mc-repo/')
			assureExistence;
			yourself.
		MCCacheRepository default directory: sharedPackageCacheDirectory.
		MCDirectoryRepository defaultDirectoryName: '/home/pts/pharo/local-mc-repo/'.
		(MCRepositoryGroup default repositories
			select: [:each | (each isKindOf: MCHttpRepository)
				and: [((each locationWithTrailingSlash includesSubString: 'www.squeaksource.com')
					or: [each locationWithTrailingSlash includesSubString: 'http://ss3.gemstone.com/ss/'])]
						]) do: [:each |
							each
							user: 'sundbp';
							password: ((FileDirectory default oldFileNamed: '/Users/mariano/Pharo/repositoriesPassword.txt') contents).
							].
		FileStream stdout lf; nextPutAll: 'Finished'; lf.
	] runOnce: true ).
	StartupLoader default addAtStartupInPreferenceVersionFolder: items named: 'monticello.st'.
! !

!PSGeneralImageBuilder methodsFor: 'private' stamp: 'PatrikSundberg 7/30/2012 12:19'!
setUsernameAndPasswordForRepos
	"This sets the username and password in all squeaksource repositories. The password must stored in a specific file in the machine where you are building this image."
	| reposToChange |
	reposToChange := (MCRepositoryGroup default  repositories) select: [ :each | self shouldSetUserAndPassword: each ].
	reposToChange do: [:each |
			each 
				user: 'sundbp';
				password: self repositoriesPassword. ].! !

!PSGeneralImageBuilder methodsFor: 'file directories' stamp: 'PatrikSundberg 7/25/2012 11:47'!
sharedPackageCacheDirectory
	^(self sharedPackageCacheName) asFileReference 
		ensureDirectory;
		yourself
! !

!PSGeneralImageBuilder methodsFor: 'file directories' stamp: 'PatrikSundberg 7/24/2012 16:52'!
sharedPackageCacheName
	^ '/home/pts/pharo/local-mc-repo/'! !

!PSGeneralImageBuilder methodsFor: 'private' stamp: 'PatrikSundberg 7/24/2012 17:14'!
shouldSetUserAndPassword: aRepo

	^ (aRepo isKindOf: MCHttpRepository) and: [ (self isSS: aRepo) or: [self isSS3: aRepo ] ]
! !
